﻿Imports Newtonsoft.Json
Imports RestSharp
Imports SmsToApp.SmsToApp.Messaging.Models.Single
Imports System.Net.Http
Imports System.Net.Http.Headers
Imports System.Net.Mime
Imports System.Text
Imports System.Threading.Tasks

Namespace SmsToApp.Messaging.Services
    Public Class SMStoMessageService

        Private Const _URL As String = "https://api.sms.to/sms/send"
        Private ReadOnly _httpClient As RestClient

        Public Sub New(ByVal httpClient As RestClient)
            _httpClient = httpClient
        End Sub

        Public Async Function SendAsync(ByVal apiKey As String, ByVal request As SingleMessageRequest) As Task(Of String)
            Return Await ExecutePostAsync(_URL, apiKey, request)
        End Function

        Private Async Function ExecutePostAsync(ByVal url As String, ByVal apiKey As String, ByVal request As Object) As Task(Of String)
            Dim req = New RestRequest(url, Method.Post)
            req.AddHeader("Authorization", $"Bearer {apiKey}")
            req.AddHeader("Content-Type", MediaTypeNames.Application.Json)
            req.AddJsonBody(request)
            Dim response = Await _httpClient.ExecuteAsync(req)
            Return response.Content
        End Function
    End Class
End Namespace
