Imports System
Imports System.Threading.Tasks
Imports System.Net.Http
Imports RestSharp
Imports Newtonsoft.Json
Imports SmsToApp.SmsToApp.Messaging.Services
Imports SmsToApp.SmsToApp.Messaging.Models.Single

Module Program
    Sub Main(args As String())
        RestClientMain().Wait()
        MessageService().Wait()
    End Sub

    Private Async Function RestClientMain() As Task
        Dim client = New RestClient("https://api.sms.to")
        Dim request = New RestRequest("https://api.sms.to/sms/send", Method.Post)
        request.AddHeader("Authorization", "Bearer <<API_KEY>>")
        request.AddHeader("Content-Type", "application/json")
        request.AddJsonBody(New With {Key .[to] = "+357999999999999", Key .message = "This is test", Key .sender_id = "SMSto"})
        Dim response = Await client.ExecuteAsync(request)
        Console.WriteLine(response.Content)
    End Function

    Private Async Function MessageService() As Task
        Dim service = New SMStoMessageService(New RestClient())
        Dim message = New SingleMessageRequest("Test", "+357999999999999", "SMSto")
        Dim response = Await service.SendAsync("<<API_KEY>>", message)
        Console.WriteLine(response)
    End Function
End Module
